#include "keytype.h"

unsigned char _key_type[]=
{
 /*	00	ESC			*/	_KT_CTRL
,/*	01	1!			*/	_KT_FULL+_KT_NUM
,/*	02	2"			*/	_KT_FULL+_KT_NUM
,/*	03	3#			*/	_KT_FULL+_KT_NUM
,/*	04	4$			*/	_KT_FULL+_KT_NUM
,/*	05	5%			*/	_KT_FULL+_KT_NUM
,/*	06	6&			*/	_KT_FULL+_KT_NUM
,/*	07	7'			*/	_KT_FULL+_KT_NUM
,/*	08	8(			*/	_KT_FULL+_KT_NUM
,/*	09	9)			*/	_KT_FULL+_KT_NUM
,/*	0A	0			*/	_KT_FULL+_KT_NUM
,/*	0B	-=			*/	_KT_FULL
,/*	0C	^`			*/	_KT_FULL
,/*	0D	\|			*/	_KT_FULL
,/*	0E	BS			*/	_KT_CTRL
,/*	0F	TAB			*/	_KT_CTRL
,/*	10	Q			*/	_KT_FULL+_KT_ALPHA
,/*	11	W			*/	_KT_FULL+_KT_ALPHA
,/*	12	E			*/	_KT_FULL+_KT_ALPHA
,/*	13	R			*/	_KT_FULL+_KT_ALPHA
,/*	14	T			*/	_KT_FULL+_KT_ALPHA
,/*	15	Y			*/	_KT_FULL+_KT_ALPHA
,/*	16	U			*/	_KT_FULL+_KT_ALPHA
,/*	17	I			*/	_KT_FULL+_KT_ALPHA
,/*	18	O			*/	_KT_FULL+_KT_ALPHA
,/*	19	P			*/	_KT_FULL+_KT_ALPHA
,/*	1A	@~			*/	_KT_FULL
,/*	1B	[{			*/	_KT_FULL
,/*	1C	[RET]		*/	_KT_CTRL
,/*	1D	A			*/	_KT_FULL+_KT_ALPHA
,/*	1E	S			*/	_KT_FULL+_KT_ALPHA
,/*	1F	D			*/	_KT_FULL+_KT_ALPHA
,/*	20	F			*/	_KT_FULL+_KT_ALPHA
,/*	21	G			*/	_KT_FULL+_KT_ALPHA
,/*	22	H			*/	_KT_FULL+_KT_ALPHA
,/*	23	J			*/	_KT_FULL+_KT_ALPHA
,/*	24	K			*/	_KT_FULL+_KT_ALPHA
,/*	25	L			*/	_KT_FULL+_KT_ALPHA
,/*	26	;+			*/	_KT_FULL
,/*	27	:*			*/	_KT_FULL
,/*	28	]}			*/	_KT_FULL
,/*	29	Z			*/	_KT_FULL+_KT_ALPHA
,/*	2A	X			*/	_KT_FULL+_KT_ALPHA
,/*	2B	C			*/	_KT_FULL+_KT_ALPHA
,/*	2C	V			*/	_KT_FULL+_KT_ALPHA
,/*	2D	B			*/	_KT_FULL+_KT_ALPHA
,/*	2E	N			*/	_KT_FULL+_KT_ALPHA
,/*	2F	M			*/	_KT_FULL+_KT_ALPHA
,/*	30	,<			*/	_KT_FULL
,/*	31	.>			*/	_KT_FULL
,/*	32	/?			*/	_KT_FULL
,/*	33	_			*/	_KT_FULL
,/*	34	[SPACE]		*/	0
,/*	35	[XFER]		*/	_KT_CTRL
,/*	36	[RollUp]	*/	_KT_CTRL
,/*	37	[RollDown]	*/	_KT_CTRL
,/*	38	[INS]		*/	_KT_CTRL
,/*	39	[DEL]		*/	_KT_CTRL
,/*	3A	[]		*/	_KT_CTRL
,/*	3B	[]		*/	_KT_CTRL
,/*	3C	[]		*/	_KT_CTRL
,/*	3D	[]		*/	_KT_CTRL
,/*	3E	[HOME CLR]	*/	_KT_CTRL+_KT_TEN
,/*	3F	[HELP]		*/	_KT_CTRL+_KT_TEN
,/*	40	-			*/	_KT_TEN
,/*	41	/			*/	_KT_TEN
,/*	42	7			*/	_KT_TEN+_KT_NUM
,/*	43	8			*/	_KT_TEN+_KT_NUM
,/*	44	9			*/	_KT_TEN+_KT_NUM
,/*	45	*			*/	_KT_TEN
,/*	46	4			*/	_KT_TEN+_KT_NUM
,/*	47	5			*/	_KT_TEN+_KT_NUM
,/*	48	6			*/	_KT_TEN+_KT_NUM
,/*	49	+			*/	_KT_TEN
,/*	4A	1			*/	_KT_TEN+_KT_NUM
,/*	4B	2			*/	_KT_TEN+_KT_NUM
,/*	4C	3			*/	_KT_TEN+_KT_NUM
,/*	4D	=			*/	_KT_TEN
,/*	4E	0			*/	_KT_TEN+_KT_NUM
,/*	4F	,			*/	_KT_TEN
,/*	50	.			*/	_KT_TEN
,/*	51	[NFER]		*/	_KT_CTRL
,/*	52	[VF1]		*/	_KT_VFUNC
,/*	53	[VF2]		*/	_KT_VFUNC
,/*	54	[VF3]		*/	_KT_VFUNC
,/*	55	[VF4]		*/	_KT_VFUNC
,/*	56	[VF5]		*/	_KT_VFUNC
,/*	57				*/	0
,/*	58				*/	0
,/*	59				*/	0
,/*	5A				*/	0
,/*	5B				*/	0
,/*	5C				*/	0
,/*	5D				*/	0
,/*	5E				*/	0
,/*	5F				*/	0
,/*	60	[STOP]		*/	_KT_CTRL
,/*	61	[COPY]		*/	_KT_CTRL
,/*	62	[F1]		*/	_KT_FUNC
,/*	63	[F2]		*/	_KT_FUNC
,/*	64	[F3]		*/	_KT_FUNC
,/*	65	[F4]		*/	_KT_FUNC
,/*	66	[F5]		*/	_KT_FUNC
,/*	67	[F6]		*/	_KT_FUNC
,/*	68	[F7]		*/	_KT_FUNC
,/*	69	[F8]		*/	_KT_FUNC
,/*	6A	[F9]		*/	_KT_FUNC
,/*	6B	[F10]		*/	_KT_FUNC
,/*	6C				*/	0
,/*	6D				*/	0
,/*	6E				*/	0
,/*	6F				*/	0
,/*	70	[SHIFT]		*/	_KT_SHIFT
,/*	71	[CAPS]		*/	_KT_SHIFT
,/*	72	[]		*/	_KT_SHIFT
,/*	73	[GRPH]		*/	_KT_SHIFT
,/*	74	[CTRL]		*/	_KT_SHIFT
};
