/* File: main-98.c */

/* Purpose: Visual Display Support for "term.c", for the PC-98x1 */

/* 
 * ̃t@C Angband2.7.9v2  main-ibm.c ƂɃGbN
 * PC-98x1 pɍ쐬܂BƂ񂪑ύX܂
 */

/* ɃL[͂ bug ύX܂ */

/*  Ƃ  v5 ɑΉ܂ */
/*  Ƃ  2.8.0 ɑΉ܂ */
/*  Ƃ  2.8.1 ɑΉ܂ */
/*  Ƃ  2.8.3 ɑΉ܂ */

/* bug ɂύXLɂ */
#define USE_bug

/* L[͂łĂ邩̃`FbNiʏój */
/* #define debug */



#include "angband.h"


/*
 * Use "VirtualScreen"
 */
#define USE_VIRTUAL


/*
 * Use "curs_set()" calls
 */
#define USE_CURS_SET

/*
 * Include the "go32" support
 */
#include <go32.h>
 
/*
 * Require the "go32" support
 */
#ifndef __GO32__
# error This file will not compile on non-extended IBM
#endif


/*
 * The following unions/structures are "stolen" from "DOS.H",
 * which cannot simply be included because it induces conflicts
 */

union REGS {

  struct {
        unsigned long ax;
        unsigned long bx;
        unsigned long cx;
        unsigned long dx;
        unsigned long si;
        unsigned long di;
        unsigned long cflag;
        unsigned long flags;
  } x;
  
  struct {
        unsigned char al;
        unsigned char ah;
        unsigned short upper_ax;
        unsigned char bl;
        unsigned char bh;
        unsigned short upper_bx;
        unsigned char cl;
        unsigned char ch;
        unsigned short upper_cx;
        unsigned char dl;
        unsigned char dh;
        unsigned short upper_dx;
  } h;
};


/*
 * External function -- the "int86()" call in "DOS.H"
 */
extern int int86(int ivec, union REGS *in, union REGS *out);


/*
 * More header files
 */
# include <pc.h>
# include <osfcn.h>
# include <bios.h>

/*
 * Hack -- use "bcopy()" instead of "memcpy()"
 */
# define memcpy(T,S,N) bcopy(S,T,N)


#ifdef USE_bug
/*
 * VtgR[h
 */
#define KS_SHIFT 1
#define KS_CAPS  2
#define KS_KANA  4
#define KS_GRAPH 8
#define KS_CTRL  16

#else

/*
 * Keypress input modifier flags (hard-coded by DOS)
 */
#define K_RSHIFT	0	/* Right shift key down */
#define K_LSHIFT	1	/* Left shift key down */
#define K_CTRL		2	/* Ctrl key down */
#define K_ALT		3	/* Alt key down */
#define K_SCROLL	4	/* Scroll lock on */
#define K_NUM		5	/* Num lock on */
#define K_CAPS		6	/* Caps lock on */
#define K_INSERT	7	/* Insert on */

#endif


/*
 * Foreground color bits (hard-coded by DOS)
 */
#define VID_BLACK	0x00
#define VID_BLUE	0x01
#define VID_GREEN	0x02
#define VID_CYAN	0x03
#define VID_RED		0x04
#define VID_MAGENTA	0x05
#define VID_YELLOW	0x06
#define VID_WHITE	0x07

/*
 * Extended color bits (hard-coded by DOS)
 */
#define VID_BRIGHT	0x08

/*
 * Background color bits (hard-coded by DOS)
 */
#define VUD_BLACK	0x00
#define VUD_BLUE	0x10
#define VUD_GREEN	0x20
#define VUD_CYAN	0x30
#define VUD_RED		0x40
#define VUD_MAGENTA	0x50
#define VUD_YELLOW	0x60
#define VUD_WHITE	0x70

/*
 * Blinking text (hard-coded by DOS)
 */
#define VUD_BRIGHT	0x80



/*
 * Screen Size
 */
static int rows;
static int cols;


/*
 * Physical Screen
 */
#define PhysicalScreen ((byte *)(0xB800 << 4))


/*
 * Virtual Screen Contents
 */
static byte *VirtualScreen;


/*
 * Hack -- the cursor "visibility"
 */
static int saved_cur_v;
static int saved_cur_high;
static int saved_cur_low;


/*
 * This array is used for "wiping" the screen
 */
static byte wiper[160];


/*
 * The main screen (currently the only screen)
 */
static term term_screen_body;

#ifdef USE_98

/*
 * PC-98x1 p̕ϐ錾
 */
 
#include <graph98.h>
#include <dpmi.h>

#define	SIZEOFFONT	(((8/8)*16*4)+4)

static	unsigned short	ElrockText[80*25];
static	unsigned short	ElrockAttr[80*25];
static	unsigned short	ElrockFontExist[256];
static	unsigned char	ElrockFont[256*16*SIZEOFFONT];
static	_go32_dpmi_seginfo	work_info;
static	int		addr;

#define	SIZEOFKANJI	(((16/8)*16*4)+4)

static	int		ElrockKanjiCnt;
static	unsigned short		ElrockKanjiCode[10000];
static	unsigned short		ElrockKanjiColor[10000];
static	unsigned char		ElrockKanji[10000*SIZEOFKANJI];

/*
 * \ƃOtBbN\̐؂ւ
 */
void ElrockChangeFont()
{
	int	i, col;
	ElrockFontMode = 1 - ElrockFontMode;

	if (ElrockFontMode != 0) {
		for (i = 0; i < 16; i++) {
			if (i>8) {
				col = ((i&4)!=0)*0xf00+((i&2)!=0)*0x0f0+((i&1)!=0)*0x00f;
			} else if (i == 8) {
				col = 0x777;
			} else {
				col = ((i&4)!=0)*0xb00+((i&2)!=0)*0x0b0+((i&1)!=0)*0x00b;
			}
			g_color2(i, col);
		}
	}
}

/*
 * \͐؂ւ邪 ElrockFontMode ͕ύXȂ
 */
void ElrockChangeFontTemp()
{
	int	i, col;
	for (i = 0; i < 16; i++) {
		if (i>8) {
			col = ((i&4)!=0)*0xf00+((i&2)!=0)*0x0f0+((i&1)!=0)*0x00f;
		} else if (i == 8) {
			col = 0x777;
		} else {
			col = ((i&4)!=0)*0xb00+((i&2)!=0)*0x0b0+((i&1)!=0)*0x00b;
		}
		g_color2(i, col);
	}
}

static void init_ElrockFont()
{
	memset(ElrockFontExist, 0, sizeof ElrockFontExist);
	ElrockKanjiCnt = 0;
}

static void make_ElrockChar(int ch, int attr)
{
	int		x, y;
	int		resetflag;
	int		gx, gy;
	char*	ptr;
	int		col;
	int		col2;
	int		col3;

	if ((ElrockFontExist[ch] & (1<<attr)) == 0) {
		gx = 0;
		gy = 400-16;
		ElrockFontExist[ch] |= 1<<attr;
		ptr = ElrockFont+SIZEOFFONT*(attr+(ch<<4));
		col3 = attr;
		if ((attr == 0) && (ch != ' ')) {
			col3 |= 8;
		}
		switch (ch) {
		case 0xa1:	/* z */
			g_line(gx+0, gy+0, gx+7, gy+15, 0, 2, 0);
			resetflag = 0;
			if (attr == 8) {
				col  = 3;
				col2 = 0;
			} else if (attr & 8) {
				col = 2;
				col2 = 1;
			} else {
				col = 4;
				col2 = 2;
			}
			col = 2;
			col2 = 1;
			for (y = 0; y<16; y++) {
				for (x = 0; x<8; x++) {
					if (resetflag == 0) {
						g_pset(gx+x, gy+y, col3);
					}
					resetflag = (resetflag + 1) % col;
				}
				resetflag = (resetflag + col2) % col;
			}
			break;
		case 0xa2:	/*  */
			g_line(gx+0, gy+0, gx+7, gy+15, 0, 2, 0);
			resetflag = 0;
			col = 2;
			for (y = 0; y<16; y += col) {
				for (x = 0; x<8; x += col) {
					g_pset(gx+x, gy+y, col3);
				}
			}
			break;
		case 0xa3:	/*  */
			g_line(gx+0, gy+0, gx+7, gy+15, 0, 2, 0);
			g_circle(gx+3, gy+7, 2, 1, col3, 0);
			g_paint(gx+3, gy+7, col3, -1);
			break;
		case 0xa5:  /* '' */
			g_line(gx+0, gy+0, gx+7, gy+15, 0, 2, 0);
			g_line(gx+3, gy+7, gx+4, gy+8, col3, 2, 0);
			break;
		case '\\':  /* '\' */
			g_line(gx+0, gy+0, gx+7, gy+15, 0, 2, 0);
			g_line(gx+1, gy+3, gx+6, gy+12, col3, 0, 0);
			if (attr & 8) {
				g_line(gx+2, gy+3, gx+7, gy+12, col3, 0, 0);
			}
			break;
		default:
			g_putc(gx+0, gy+0, ch, PSET, 1, col3, 0);
			break;
		}
		g_data_save(gx, gy, gx+7, gy+15, addr, SIZEOFFONT);
		dosmemget(addr, SIZEOFFONT, ptr);
		g_line(gx+0, gy+0, gx+7+2, gy+15, 0, 2, 0);
	}
}

static void _ScreenClear()
{
	int	x, y;

	if (g_cls() != 0) {
	}
	ScreenClear();
	for (y = 0 ; y < 25 ; y++) {
		for (x = 0 ; x < 80 ; x++) {
			ElrockText[x+y*80] = ' ';
			ElrockAttr[x+y*80] = 7;
		}
	}
}

static void _ScreenSetCursor(int x, int y)
{
	ScreenSetCursor(x, y);
}

static	int	start_draw;
static	int	end_draw;
static	int	loc_draw;
#define	DATA_SIZE	((8/8)*16*80)
static	unsigned char	data_draw[DATA_SIZE*4];

static void ElrockInitLine()
{
	start_draw	= -1;
	end_draw	= 0;
	loc_draw	= 0;
}

static void ElrockEndLine(int y)
{
	int		i;
	long	b_ptr;
	long	r_ptr;
	long	g_ptr;
	long	i_ptr;
	long	ofst;
	int		cur;
	if (loc_draw > 0) {
		ofst = (start_draw+y*80*16);
		b_ptr = (0xa800 << 4)+ofst;
		r_ptr = (0xb000 << 4)+ofst;
		g_ptr = (0xb800 << 4)+ofst;
		i_ptr = (0xe000 << 4)+ofst;
		cur = 0;
		for (i = 0; i<16; i++) {
			dosmemput(&data_draw[0*DATA_SIZE+cur], loc_draw, b_ptr);
			dosmemput(&data_draw[1*DATA_SIZE+cur], loc_draw, r_ptr);
			dosmemput(&data_draw[2*DATA_SIZE+cur], loc_draw, g_ptr);
			dosmemput(&data_draw[3*DATA_SIZE+cur], loc_draw, i_ptr);
			b_ptr += 80;
			r_ptr += 80;
			g_ptr += 80;
			i_ptr += 80;
			cur += 80;
		}
	}
	start_draw = -1;
	loc_draw = 0;
}

/********************************/
/*		OtBbNp		*/
/********************************/
static void _ScreenPutChar(int ch, int attr, int x, int y)
{
	int		i;
	char*	ptr;
	int		cur;

	if (ElrockText[x+y*80] != ch || ElrockAttr[x+y*80] != attr) {
		ElrockText[x+y*80] = ch;
		ElrockAttr[x+y*80] = attr;
		make_ElrockChar(ch, attr);
		if (start_draw != -1 && end_draw != x) {
			ElrockEndLine(y);
		}
		if (start_draw == -1) {
			start_draw = x;
			end_draw = x;
			loc_draw = 0;
		}
		ptr = ElrockFont+SIZEOFFONT*(attr+(ch<<4));
		ptr += 4;
		cur = loc_draw;
		for (i = 0; i<16; i++) {
			data_draw[0*DATA_SIZE+cur] = *ptr++;
			data_draw[1*DATA_SIZE+cur] = *ptr++;
			data_draw[2*DATA_SIZE+cur] = *ptr++;
			data_draw[3*DATA_SIZE+cur] = *ptr++;
			cur += 80;
		}
		end_draw++;
		loc_draw++;
/*
		{
			int		i;
			long	b_ptr;
			long	r_ptr;
			long	g_ptr;
			long	i_ptr;
			long	ofst;
			char*	ptr;
			ofst = (x+y*80*16);
			b_ptr = (0xa800 << 4)+ofst;
			r_ptr = (0xb000 << 4)+ofst;
			g_ptr = (0xb800 << 4)+ofst;
			i_ptr = (0xe000 << 4)+ofst;
			ptr = ElrockFont+SIZEOFFONT*(attr+(ch<<4));
			ptr += 4;
			for (i = 0; i<16; i++) {
				dosmemput(ptr, sizeof(char), b_ptr);ptr++;
				dosmemput(ptr, sizeof(char), r_ptr);ptr++;
				dosmemput(ptr, sizeof(char), g_ptr);ptr++;
				dosmemput(ptr, sizeof(char), i_ptr);ptr++;
				b_ptr += 80;
				r_ptr += 80;
				g_ptr += 80;
				i_ptr += 80;
			}
		}
*/
	}
}

/****************************/
/*	OtBbNSp	*/
/****************************/
static char* make_ElrockKanji(int ch, int attr)
{
	int		i;
	int		j;
	int		gx, gy;
	unsigned char*	ptr;

	j = -1;
	for (i = 0; i < ElrockKanjiCnt; i++) {
		if (ElrockKanjiCode[i] == ch && ElrockKanjiColor[i] == attr) {
			j = i;
			break;
		}
	}
	if (j == -1) {
		if (ElrockKanjiCnt >= 1000) {
			ElrockKanjiCnt--;
		}
		gx = 0;
		gy = 400-16;
		g_putc(gx+0, gy+0, ch, PSET, 1, attr, 0);
		g_data_save(gx, gy, gx+15, gy+15, addr, SIZEOFKANJI);
		ptr = ElrockKanji+ElrockKanjiCnt*SIZEOFKANJI;
		dosmemget(addr, SIZEOFKANJI, ptr);
		g_line(gx+0, gy+0, gx+15, gy+15, 0, 2, 0);
		j = ElrockKanjiCnt++;
		ElrockKanjiCode[j] = ch;
		ElrockKanjiColor[j] = attr;
	}
	return (ElrockKanji+j*SIZEOFKANJI+4);
}

static void _ScreenPutChar2(char* ptr, int attr, int x, int y)
{
	unsigned char	ch;
	unsigned char	nx;
	unsigned short	code;
	unsigned char*	d_ptr;
	int		i;
	int		cur;

	ch = *ptr;
	nx = *(ptr+2);
	if (ElrockText[x+y*80] != (256|ch) || ElrockText[(x+1)+y*80] != (256|nx) ||
	    ElrockAttr[x+y*80] != attr || ElrockText[(x+1)+y*80] != attr) {
		ElrockText[ x   +y*80] = (256|ch);
		ElrockText[(x+1)+y*80] = (256|nx);
		ElrockAttr[ x   +y*80] = attr;
		ElrockAttr[(x+1)+y*80] = attr;

		code = (ch << 8) + nx;
		d_ptr = make_ElrockKanji(code, attr);

		if (start_draw != -1 && end_draw != x) {
			ElrockEndLine(y);
		}
		if (start_draw == -1) {
			start_draw = x;
			end_draw = x;
			loc_draw = 0;
		}
		cur = loc_draw;
		for (i = 0; i<16; i++) {
			memcpy(&data_draw[0*DATA_SIZE+cur], d_ptr, 2);d_ptr += 2;
			memcpy(&data_draw[1*DATA_SIZE+cur], d_ptr, 2);d_ptr += 2;
			memcpy(&data_draw[2*DATA_SIZE+cur], d_ptr, 2);d_ptr += 2;
			memcpy(&data_draw[3*DATA_SIZE+cur], d_ptr, 2);d_ptr += 2;
			cur += 80;
		}
		end_draw += 2;
		loc_draw += 2;
	}
}

/*************************/
/*	LN^[p	*/
/**********************/
static void _ScreenPutChar3(int ch, int attr, int x, int y)
{
	long	t_ofst;
	long	a_ofst;
	unsigned char	u_ch;
	unsigned char	u_attr;
	unsigned short	code;

	u_ch = ch;

	if ( (ElrockText[x+y*80] != ch) || (ElrockAttr[x+y*80] != attr) 
			|| ( ch != ' ') ) { 
/*	if ( (ElrockText[x+y*80] != u_ch) || (ElrockAttr[x+y*80] != attr) || 
	       ( x==0 ) || ( ElrockText[(x-1)+y*80] > 0x80 ) ) { */

		ElrockText[x+y*80] = ch;
		ElrockAttr[x+y*80] = attr;

		switch (u_ch) {
		case 0x5c:			/* '\' */
			u_ch = 0xfc;
			if (( attr == 0 ) || ( attr == 8 )) { /*ƊDF͐ɂ */
				attr = 1;    /* blue */
			}
			attr = attr & 7;
			break;
		case 0xa1:
			u_ch = ' ';		/**/
			break;
		case 0xa2:
			u_ch = '#';		/*z*/
			if ( attr == 7 ) attr = 15; /* n͔] */
			break;
		case 0xa3:
			u_ch = '';		/**/
			attr = attr & 7;	/* ]Ȃ */
			break;
		default:
			if (( attr == 0 ) || ( attr == 8 )) { /*ƊDF͐ɂ */
				attr = 1;    /* blue */
			}
			attr = attr & 7;
			break;
		}

		u_attr = ((attr & 7) << 5) | 1 | ((attr & 8) >> 1);
		t_ofst = (0xa000 << 4) + ((y * 80 + x) << 1);
		a_ofst = (0xa200 << 4) + ((y * 80 + x) << 1);
		code = u_ch;
		dosmemput(&code, sizeof code, t_ofst);
		dosmemput(&u_attr, sizeof u_attr, a_ofst);
	}
	return;
}

/**************************/
/*	LN^[Sp	*/
/*****************************/

static void _ScreenPutChar4(char* ptr, int attr, int x, int y)
{
	unsigned char	ch;
	unsigned char	nx;
	unsigned short	code;
	unsigned char	u_attr;
	long	t_ofst;
	long	a_ofst;
	extern int   s_jis_to_jis(int kanji);

	ch = *ptr;
	nx = *(ptr+2);
/*	if (ElrockText[x+y*80] != ch || ElrockText[(x+1)+y*80] != nx ||
	    ElrockAttr[x+y*80] != attr || ElrockAttr[(x+1)+y*80] != attr) { */
		ElrockText[ x   +y*80] = ch;
		ElrockText[(x+1)+y*80] = nx;
		ElrockAttr[ x   +y*80] = attr;
		ElrockAttr[(x+1)+y*80] = attr;

		if ((attr == 0) || (attr == 8)){
			attr = 1;
		}

		attr = attr & 7;

		code = s_jis_to_jis((ch << 8) + nx) - 0x2000;
		ch = (code >> 8);
		nx = (code & 0xff);

		t_ofst = (0xa000 << 4) + ((y * 80 + x) << 1);
		a_ofst = (0xa200 << 4) + ((y * 80 + x) << 1);
		u_attr = ((attr & 7) << 5) | 1 | ((attr & 8) >> 1);
		code = (nx << 8) | ch;
		dosmemput(&code, sizeof code, t_ofst);
		t_ofst += 2;
		ch |= 0x80;
		code = (nx << 8) | ch;
		dosmemput(&code, sizeof code, t_ofst);
		dosmemput(&u_attr, sizeof u_attr, a_ofst);
		a_ofst += 2;
		dosmemput(&u_attr, sizeof u_attr, a_ofst);
/*	} */
	return;
}

static void _ScreenUpdateLine(char* virtual_screen_line, int row)
{
	int				x;
	int				y;
	unsigned char	attr;
	unsigned char	ch;

	y = row;
	ElrockInitLine();
	for (x = 0; x<80; x++) {
		ch = *virtual_screen_line++;
		attr = *virtual_screen_line++;
		switch (attr & 7) {
		case VID_BLACK:
			attr &= ~7;
			attr |= 0;
			break;
		case VID_BLUE:
			attr &= ~7;
			attr |= 1;
			break;
		case VID_GREEN:
			attr &= ~7;
			attr |= 4;
			break;
		case VID_CYAN:
			attr &= ~7;
			attr |= 5;
			break;
		case VID_RED:
			attr &= ~7;
			attr |= 2;
			break;
		case VID_MAGENTA:
			attr &= ~7;
			attr |= 3;
			break;
		case VID_YELLOW:
			attr &= ~7;
			attr |= 6;
			break;
		case VID_WHITE:
			attr &= ~7;
			attr |= 7;
			break;
		default:
			break;
		}
		if (ch < 0x80 || ((ch > 0x9f) && (ch < 0xe0)) ) {
			if (ch < ' ') {
				ch = ' ';
			}
			if (ch == ' ') {
				attr = 7;
			}
			(ElrockFontMode != 0 ? _ScreenPutChar : _ScreenPutChar3)
													(ch, attr, x, y);
		} else {
			(ElrockFontMode != 0 ? _ScreenPutChar2 : _ScreenPutChar4)
								(virtual_screen_line - 2, attr, x, y);
			ch = *virtual_screen_line++;
			attr = *virtual_screen_line++;
			x++;
		}
	}
	ElrockEndLine(y);
}

static int _ScreenRows()
{
	return 25;
}

static int _ScreenCols()
{
	return 80;
}

#define	ScreenUpdateLine	_ScreenUpdateLine
#define	ScreenClear			_ScreenClear
#define	ScreenSetCursor		_ScreenSetCursor
#define	ScreenCols			_ScreenCols
#define	ScreenRows			_ScreenRows

#endif /* USE_98 */



/*
 * Choose between the "complex" and "simple" color methods
 */
static byte use_color_complex = FALSE;


/*
 * The Angband color table (see "defines.h")
 */
static const byte ibm_color_simple[16] = {
    VID_BLACK,
    VID_WHITE | VID_BRIGHT,
    VID_WHITE,
    VID_RED | VID_BRIGHT,
    VID_RED,
    VID_GREEN,
    VID_BLUE,
    VID_YELLOW,
    VID_BLACK | VID_BRIGHT,
    VID_CYAN | VID_BRIGHT,
    VID_MAGENTA,
    VID_YELLOW | VID_BRIGHT,
    VID_RED | VID_BRIGHT,
    VID_GREEN | VID_BRIGHT,
    VID_BLUE | VID_BRIGHT,
    VID_YELLOW
};


/*
 * Move the cursor
 *
 * The given parameters are "valid".
 */
static errr Term_curs_ibm(int x, int y)
{


    /* Move the cursor */
    ScreenSetCursor(y,x);

    /* Success */
    return (0);
}


/*
 * Place some text on the screen using an attribute
 *
 * The given parameters are "valid".  Be careful with "a".
 * The string "s" is null terminated, and has length "n".
 */
static errr Term_text_ibm(int x, int y, int n, byte a, const char *cp)
{
	register int i;
    register byte attr;
    register byte *dest;

    /* Convert the color */
    attr = ibm_color_simple[a & 0x0F];

#ifdef USE_CONIO

	/* Place the cursor */
	gotoxy(x+1, y+1);

	/* Set the attribute */
/*	textattr(attr); */

	/* Dump the text */
	for (i = 0; i < n; i++) putch(cp[i]);

#else /* USE_CONIO */

	/* Access the virtual (or physical) screen */
	dest = VirtualScreen + (((cols * y) + x) << 1);

	/* Save the data */
	for (i = 0; i < n; i++)
	{
		/* Apply */
		*dest++ = cp[i];
		*dest++ = attr;
	}

#endif /* USE_CONIO */

    /* Success */
    return (0);
}


/*
 * Erase a block of the screen
 *
 * The given parameters are "valid".
 */
static errr Term_wipe_ibm(int x, int y, int n)
{
    /* Wipe part of the virtual (or physical) screen */
    memcpy(VirtualScreen + ((cols*y + x)<<1), wiper, n<<1);

    /* Success */
    return (0);
}


static void curs_set(int v) {
    /* If needed */
    if (saved_cur_v != v) {

        union REGS r;

        if (v) r.h.ah = 0x11;		/* Visible */
        else   r.h.ah = 0x12;		/* Invisible */

        /* Make the call */
        int86(0x18, &r, &r);

        /* Save the cursor state */
        saved_cur_v = v;
    }
}


/*
 * Hack -- set the cursor "visibility"
 */

/*
 * Process an event (check for a keypress)
 *
 * The keypress processing code is often the most system dependant part
 * of Angband, since sometimes even the choice of compiler is important.
 *
 * Note that we rely on the special "macro processing" ability of Angband,
 * which allows us to encode most "bizarre" keypresses in any way that
 * we like, as long as we follow the "Angband Macro" formalism, which allows
 * the user to make "macros" that convert the internal formalism into any
 * sequence of keypresses.  For this reason, we treat the "left shift" and
 * "right shift" keys as different keys, and we assume that if the user
 * wants both shift keys to have the same effect then he will make one
 * macro for each shift key.  This is simplified by keeping both "shift"
 * codes next to each other in the macro trigger.
 *
 * Note that we do not have to do any "semantic" analysis of any of the
 * special keypresses, since the user can use a "user pref file" to map
 * the actual key (i.e. Shift+Keypad-6) to any series of Angband keys
 * (i.e. "\" + "." + "6" for "run to the east").  Hopefully, the default
 * "pref-ibm.prf" file will include macros for all of the "standard" keys,
 * including Control, Left Shift, and Right Shift, plus the Keypad keys.
 *
 * We use the "getxkey()" function to handle most of the keypress processing.
 * It waits for the user to press one key, then returns that key, in a special
 * encoded manner, where "alt-key" combinations have 0x100 added to them, and
 * "extended" keys have 0x200 added to them.  Thus, we only use the low "byte".
 *
 * Hack -- we "simulate" the "getxkey()" function for Watcom C/C++, perhaps
 * it would be better to ignore the "getxkey()" function and do the relevant
 * processing ourselves for all compilers.  XXX XXX XXX
 */

#ifdef debug
#include <conio.h>									/* gotoxy(),cprintf() */
#endif

#ifdef USE_bug

#include "keytype.h"
#include <go32.h>									/* dosmemget() */
extern int _native98key;							/* getkey98.c Ŏg */
static errr Term_xtra_98_event(int v){
    int key, shift;

	/* v=FALSE ŁAL[͂ȂΑ^[ */
    if (!v && !kbhit()) return 1;

	/* L[́i͑҂Lj */
	_native98key=1;
	key=getxkey();
	_native98key=0;

	/* VtgԂǂ */
	dosmemget( 0x053A, 1, &shift);
	shift &= (KS_SHIFT + KS_GRAPH + KS_CTRL);

#ifdef debug
	gotoxy(1,26);								/* WʊO */
	cprintf("key=%04X shift=%02X",key,shift);
#endif

    /* tL[ ܂ Vtg̃m[}L[ */
	if (isfullkey(key>>8) || (shift==0 && (key & 0xFF)!=0) ){
		Term_keypress(key & 0xFF);

	/* VtgL */
	}else{

		/* Hack -- begin a "macro trigger" */
		Term_keypress(31);

		/* Hack -- Send the modifiers */
		if (shift & KS_CTRL)  Term_keypress('C');
		if (shift & KS_SHIFT) Term_keypress('S');
		if (shift & KS_GRAPH) Term_keypress('O');

		/* Hack -- encode the "base" keypress (decimal) */
		Term_keypress('0' + ((((key>>8) & 0xFF) / 100) % 10));
		Term_keypress('0' + ((((key>>8) & 0xFF) /  10) % 10));
		Term_keypress('0' + ((((key>>8) & 0xFF) /   1) % 10));

		/* Hack -- end the "macro trigger" */
		Term_keypress(13);
	}

	/* I */
	return 0;
}
#else
static errr Term_xtra_ibm_event(int v)
{
    int i, k;


    /* Hack -- Check for a keypress */
    if (!v && !kbhit()) return (1);

    /* Wait for a keypress */
    k = getxkey();

    /* Access the "modifiers" */
    i = bioskey(2);

#ifdef debug
	gotoxy(1,26);								/* WʊO */
	cprintf("key=%04X shift=%02X",k,i);
#endif

    /* Normal keys */
    if (!(k & 0xFF00)) {

        /* Must be a 'normal' key */
        if (k) Term_keypress(k);
    }

    /* Handle "special" keys */
    else {

        /* Hack -- begin a "macro trigger" */
        Term_keypress(31);

        /* Hack -- Send the modifiers */
        if (i & (1 << K_CTRL)) Term_keypress('C');
        if (i & (1 << K_LSHIFT)) Term_keypress('S');
        if (i & (1 << K_RSHIFT)) Term_keypress('S');
        if (i & (1 << K_ALT)) Term_keypress('O');

        /* Hack -- encode the "base" keypress (decimal) */
        Term_keypress('0' + (((k & 0xFF) / 100) % 10));
        Term_keypress('0' + (((k & 0xFF) / 10) % 10));
        Term_keypress('0' + (((k & 0xFF) / 1) % 10));

        /* Hack -- end the "macro trigger" */
        Term_keypress(13);
    }

    /* Success */
    return (0);
}
#endif


/*
 * Handle a "special request"
 *
 * The given parameters are "valid".
 *
 * Lastly, we may be able to speed up the I/O by providing another
 * "Term_xtra()" action which says that a certain line should be
 * flushed.  The question is which is faster, dumping a full 80
 * character line once, or dumping three or four much smaller
 * pieces of that line as they arrive.  Probably not worth it...
 */
static errr Term_xtra_ibm(int n, int v)
{
    int i;

    /* Analyze the request */
    switch (n) {
       
        /* Make a "bell" noise */
        case TERM_XTRA_NOISE:
		{
            /* Make a bell noise */
            (void)write(1, "\007", 1);

            /* Success */
            return (0);
		}

		/* Set the cursor shape */
		case TERM_XTRA_SHAPE:
		{
			/* Set cursor shape */
			curs_set(v);

			/* Success */
			return (0);
		}

        /* Flush one line of output */
        case TERM_XTRA_FROSH:
		{
            /* Apply the virtual screen to the physical screen */
            ScreenUpdateLine(VirtualScreen + ((v*cols) << 1), v);

            /* Success */
            return (0);
		}

        /* Clear the screen */
        case TERM_XTRA_CLEAR:
		{
            /* Clear each line (virtual or physical) */
            for (i = 0; i < rows; i++) {

                /* Clear the line */
                memcpy((VirtualScreen + ((i*cols) << 1)), wiper, (cols << 1));
            }

            /* Erase the physical screen */
            ScreenClear();

            /* Success */
            return (0);
		}

        /* Process events */
        case TERM_XTRA_EVENT:
        {
            /* Process one event */
#ifdef USE_bug
            return (Term_xtra_98_event(v));
#else
            return (Term_xtra_ibm_event(v));
#endif

        }
        /* Flush events */
        case TERM_XTRA_FLUSH:
		{

            /* Strip events */
#ifdef USE_bug
            while (!Term_xtra_98_event(FALSE));
#else
            while (!Term_xtra_ibm_event(FALSE));
#endif

            /* Success */
            return (0);

		}
		/* React to global changes */
/*		case TERM_XTRA_REACT:
		{
			return (Term_xtra_ibm_react());
		}
*/
    }

    /* Unknown request */
    return (1);
}



/*
 * Init a Term
 */
static void Term_init_ibm(term *t)
{
    /* XXX Nothing */
}


/*
 * Nuke a Term
 */
static void Term_nuke_ibm(term *t)
{
#ifdef USE_98
    int	i;
#endif

    /* Move the cursor to the bottom of the screen */
    Term_curs_ibm(0, rows-1);

    /* Make the cursor visible */
    curs_set(1);

#ifdef USE_98
	for (i = 0; i<16; i++) {
		g_color2(i, ((i&4)!=0)*0xf00+((i&2)!=0)*0x0f0+((i&1)!=0)*0x00f);
	}
	printf("\x1b[>1l");
	ScreenClear();
#endif

}


/* {X */
#include <stdlib.h>				/* getenv(),system() */
static errr Term_user_98(int n) {

    char *comspec;

    g_cls();printf("\x1B[2J");			/* ȂAʏ */

    /* ϐݒ肵ĂΌ */
    comspec=getenv("COMSPEC");

    /* ϐŐݒ肵Ȃꍇ̓pXʂĂ邱ƂF (^^; */
    if(comspec==NULL) comspec="command.com";

    printf("Exit  ߂܂\n");
    system( comspec );

    /* ʂ */
    g_cls();printf("\x1B[2J");			/* ʏ */
    do_cmd_redraw();

    /* Success */
    return (0);
}



/*
 * Place some attr/char pairs on the screen
 *
 * The given parameters are "valid".
 */
static errr Term_pict_ibm(int x, int y, int n, const byte *ap, const char *cp)
{
	register int i;
	register byte attr;
	register byte *dest;


#ifdef USE_CONIO

	/* Place the cursor */
	gotoxy(x+1, y+1);

	/* Dump the text */
	for (i = 0; i < n; i++)
	{
		/* Extract a color value */
		attr = ibm_color_simple[ap[i] & 0x0F];

		/* Set the attribute */
/*		textattr(attr); */

		/* Dump the char */
		putch(cp[i]);
	}

#else /* USE_CONIO */

	/* Access the virtual (or physical) screen */
	dest = VirtualScreen + (((cols * y) + x) << 1);

	/* Save the data */
	for (i = 0; i < n; i++)
	{
		/* Handle "simple" color */
		/* Extract a color value */
		attr = ibm_color_simple[ap[i] & 0x0F];

		/* Apply */
		*dest++ = cp[i];
		*dest++ = attr;
	}

#endif /* USE_CONIO */

	/* Success */
	return (0);
}



/*
 * Initialize the IBM "visual module"
 *
 * Hack -- we assume that "blank space" should be "white space"
 * (and not "black space" which might make more sense).
 */
errr init_ibm(void)
{
    int i;
    term *t = &term_screen_body;


    /* Acquire the size of the screen */
    rows = ScreenRows();
    cols = ScreenCols();

    /* Paranoia -- require minimum size */
    if ((rows < 24) || (cols < 80)) quit("Screen too small!");
    
#ifdef USE_98
	work_info.size = (SIZEOFKANJI>>4)+1;
	if (_go32_dpmi_allocate_dos_memory(&work_info)){
		quit("Angband can't work in NOT DPMI mode.\n");
		return -1;
	}
	addr = ((long)work_info.rm_segment<<4) + work_info.rm_offset;

	if (g_init_screen()) {
		return -1;
	}
	if (g_getmode() != 0) {
		quit("nC][h͖T|[głB"
		     "m[}[hŋNĂB\n");
		return -1;
	}
	g_color(0, 0, 15, 2);
	printf("\x1B>31");		/* ʂ25s[hɂ */
	printf("\x1b[2J");
	printf("\x1b[>1h");
	fflush(stdout);
	init_ElrockFont();
	ElrockChangeFontTemp();
	ScreenClear();
#endif /* USE_98 */

    /* Build a "wiper line" */
    for (i = 0; i < 80; i++) {

        /* Space */
        wiper[2*i] = ' ';

        /* White */
        wiper[2*i+1] = ibm_color_simple[TERM_WHITE];
    }


    /* Make the virtual screen */
    C_MAKE(VirtualScreen, rows * cols * 2, byte);

    /* Erase the screen */
    Term_xtra_ibm(TERM_XTRA_CLEAR, 0);

    /* Initialize the term */
    term_init(t, 80, 24, 256);

#ifdef USE_CONIO
#else /* USE_CONIO */

	/* Always use "Term_pict()" */
	t->always_pict = TRUE;

#endif /* USE_CONIO */

	/* Use "white space" to erase */
	t->attr_blank = TERM_WHITE;
	t->char_blank = ' ';

    /* Prepare the init/nuke hooks */
    t->init_hook = Term_init_ibm;
    t->nuke_hook = Term_nuke_ibm;

    /* Connect the hooks */
    t->xtra_hook = Term_xtra_ibm;
    t->curs_hook = Term_curs_ibm;
    t->wipe_hook = Term_wipe_ibm;
    t->text_hook = Term_text_ibm;
	t->pict_hook = Term_pict_ibm;
    t->user_hook = Term_user_98;

    /* Save it */
    term_screen = t;

    /* Activate it */
    Term_activate(term_screen);


    /* Success */
    return 0;
}

